function Create(self)
	
	self.Frequency = 1/6;
	self.FrequencyCounter = 0;
	self.Acc = 40/self.Frequency;
	self.ARes = 300;
	self.AngularRes = 4.5/self.Frequency;
	self.AngularAcc = 75/self.Frequency;
	self.BurstAcc = 750;
	self.BurstTimer = Timer();
	self.BurstTime = 200;
	self.FireTimer = Timer();
	self.FireTime = 200;
	self.FireVel = 75;
	self.BurstTendency = math.random(1,50);
	self.TargetTimer = Timer();
	self.TargetTime = math.random(300,800);
	self.TP = Vector(-1,-1);
	self.NoMoveTimer = Timer();
	self.NoMoveTime = math.random(100,300);
	self.NoMove = math.random(4,12);
	self.NoMoveReaction = math.random(12,64);
	self.TerrainPenetration = math.random(25,40);
	self.DoorTimer = Timer();
	self.DoorTime = 250;
	self.Proximity = math.random(20,40);
	self.ProximityRatio = math.random(20,40)/100;
	self.Inaccuracy = math.random(5,25);
	self.ObjectiveImprecision = math.random(20,100);
	self.FireRange = math.random(300,400);
	self.EvadeRange = math.random(175,250);
	self.EvadeVel = math.random(20,45);
	self.EvadeActorRange = math.random(100,225);
	self.EvadeActorVel = math.random(4,12);
	self.TerrainSensorRange = math.random(200,400);
	self.SensorResolution = math.random(200,400)/1000;
	self.SensorSweep = math.random(3225,5020)/1000;
	self.SensorReaction = math.random(300,5000)/1000;
	self.SensorMin = math.random(15,40);
	self.TerrainSensorVariability = math.random(1,10)/100;
	self.ApproachRange = math.random(50,125);
	self.InterceptRange = math.random(200,400);
	self.InterceptAccuracy = 64;
	self.TargetVariability = math.random(30,90);
	self.TargetVariabilityTimer = Timer();
	self.TargetVariabilityTime =  math.random(1000,2000);
	self.RetreatTrigger = math.random(0,40);
	self.FriendDetectionRange = math.random(300,1200);
	self.CoverCheckRange = math.random(200,600);
	self.TargetDetectionRange = math.random(25,95)/100;
	self.LastPos = Vector(self.Pos.X,self.Pos.Y);
	self.PosTimer = Timer();
	self.PosTime = math.random(100,125);
	self.LastPosDist = math.random(75,76);
	self.LastPosRange = self.LastPosDist;
	self.PathCounter = 0;
	self.PathPoint = self.Pos;
	self.PathDist = math.random(300,600);
	
	
	self.ProtectRange = 45;
	self.ProtectTarget = ToActor(self);
	self.HoldPoint = self.Pos;
	self.Mode = "Free";
	self.Engined = false;

	self.c = self:GetController();
	self.TPoint = Vector(self.Pos.X,self.Pos.Y);
	
	self.TOffset = Vector(6,3);
	self.TAngle = math.atan(self.TOffset.Y/self.TOffset.X);
	self.Turret = CreateTDExplosive("FAI Gun");
	self.Turret.Pos = self.Pos+self.TOffset;
	MovableMan:AddMO(self.Turret);
	self.Turret:Activate();
	
	function self:PathTo(x,y)
		local dista = SceneMan:ShortestDistance( self.Pos,Vector(x,y), true);
		local path;
		if self.PathCounter >= 0 then
			path = FAIFINDPATHA(self.Pos.X,self.Pos.Y,x,y,dista.Magnitude,15,10-self.PathCounter);
			if path == Vector(-1,-1) then
				self.PathCounter = self.PathCounter-1;
			else
				self.PathCounter = -6;
				self.TPoint = path;
			end
		elseif self.PathCounter >= -5 then
			path = FAIFINDPATHB(self.Pos.X,self.Pos.Y,x,y,dista.Magnitude,15,-self.PathCounter);
			if path == Vector(-1,-1) then
				self.PathCounter = self.PathCounter-1;
			else
				self.PathCounter = -6;
				self.TPoint = path;
			end
		end
	end
	function self:ModeProtect()
		local d = 1000;
		self.Mode = "Protect";
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance( self.Pos,actor.Pos, true);
			if actor.Team == self.Team and dist.Magnitude < d and (actor.ClassName == "AHuman" or (actor.ClassName == "ACrab" and actor.PresetName ~= self.PresetName)) then
				d = dist.Magnitude;
				self.ProtectTarget = ToActor(actor);
			end
		end
	end
	function self:ModeHold()
		self.Mode = "Hold";
		self.HoldPoint = Vector(self.Pos.X,self.Pos.Y);
		self.ProtectTarget = nil;
	end
	function self:ModeFree()
		self.Mode = "Free";
		self.ProtectTarget = nil;
	end
	function self:PositionGun()
		if MovableMan:ValidMO(self.Turret) then
			if not self.HFlipped then
				self.Turret.Pos = self.Pos+self.TOffset:AbsRotateTo(Vector(math.cos(self.RotAngle-self.TAngle),-math.sin(self.RotAngle-self.TAngle)));
			else
				self.Turret.Pos = self.Pos+self.TOffset:AbsRotateTo(Vector(-math.cos(self.RotAngle+self.TAngle),math.sin(self.RotAngle+self.TAngle)));
			end
			self.Turret.HFlipped = self.HFlipped;
		end
	end
	function self:RotateGun(a)
		if MovableMan:ValidMO(self.Turret) then
			if not self.HFlipped then
				self.Turret.RotAngle = a;
			else
				self.Turret.RotAngle = a+math.pi;
			end
		end
	end
	function self:Glow(X,Y,color)
		local Pos = self.Pos + Vector(X,Y);
		if Pos.X > 0 and Pos.X < SceneMan.SceneWidth and Pos.Y > 0 and Pos.Y < SceneMan.SceneHeight then
			local r = CreateMOPixel("FAI Test Glow "..color);
			r.Pos = Pos;
			r.Sharpness = self.Team;
			MovableMan:AddMO(r);
		end
	end
	function self:Sensors(angle,range)
		local vec = Vector(math.cos(angle)*range,-math.sin(angle)*range);
		local ray = SceneMan:CastObstacleRay(self.Pos , vec , Vector() , Vector() , self.ID , 0 , 2);
		return ray;
	end
	function self:IndirectSensors(X,Y,XX,YY,Range)
		local vec = Vector(XX,YY).Normalized*Range;
		local ray = SceneMan:CastObstacleRay(Vector(X,Y) , vec , Vector() , Vector() , self.ID , 0 , 2);
		return ray;
	end
	function self:CheckCover(X,Y)
		local cpt = 0;
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance( self.Pos,actor.Pos, true);
			if actor.Team ~= self.Team and (dist.Magnitude < self.CoverCheckRange) then
				local ray = SceneMan:CastObstacleRay(Vector(X,Y) , dist , Vector() , Vector() , self.ID , 0 , 2);
				if ray > 0 then
					cpt = cpt+1;
				end
			end
		end
		return cpt;		
	end
	function self:LookForCover()
		local al = false;
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance( self.Pos,actor.Pos, true);
			if dist.Magnitude < self.FriendDetectionRange and actor.PresetName == "FAI" and actor.Team == self.Team then
				al = true;
				self.TPoint = actor.Pos;
			end
		end
		if al then	
			local lc = self:CheckCover(self.Pos.X,self.Pos.Y);
			local aa = -math.pi;
			local dist = 0;
			local c = lc;
			local a = -math.pi;
			local da = math.random(300,600)/1000;
			local ray;
			while a < math.pi do
				ray = self:Sensors(a,self.FireRange*self.TargetDetectionRange);
				if ray < 0 then
					local vec = self.Pos+Vector(math.cos(a)*self.FireRange*self.TargetDetectionRange,-math.sin(a)*self.FireRange*self.TargetDetectionRange);
					lc = self:CheckCover(vec.X,vec.Y);
					if lc < c then
						c = lc;
						aa = a;
						dist = self.FireRange*self.TargetDetectionRange;
					end
				elseif ray > 0 then
					local vec = self.Pos+Vector(math.cos(a)*ray,-math.sin(a)*ray)-SceneMan:ShortestDistance( self.Pos,Vector(math.cos(a)*ray,-math.sin(a)*ray), true).Normalized*16;
					lc = self:CheckCover(vec.X,vec.Y);
					if lc < c then
						c = lc;
						aa = a;
						dist = ray-16;
					end
				end
				a = a+da;
			end
			if dist > 0 then
				self:Engines(aa,100);
				self:Burst(aa,100);
			end
		end
	end
	function self:LookForLineOfFire(X,Y)
		local v = Vector(X,Y);
		if v ~= Vector(-1,-1) then
			local lc = self:CheckCover(self.Pos.X,self.Pos.Y);
			local aa = -math.pi;
			local dist = 0;
			local c = 255;
			local a = -math.pi;
			local da = math.random(100,200)/1000;
			local r = math.random(250,2500)/1000;
			local ray;
			while a < math.pi do
				ray = self:Sensors(a,self.FireRange*self.TargetDetectionRange*r);
				if ray < 0 then
					local vec = self.Pos+Vector(math.cos(a)*self.FireRange*self.TargetDetectionRange*r,-math.sin(a)*self.FireRange*self.TargetDetectionRange*r);
					lc = self:CheckCover(vec.X,vec.Y);
					local dest = vec-self.Pos;
					local ad = SceneMan:ShortestDistance( vec, v, true);
					if lc < c and self:IndirectSensors(vec.X,vec.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
						c = lc;
						aa = a;
						dist = self.FireRange*self.TargetDetectionRange*r;
					end
				elseif ray > 0 then
					local vec = self.Pos+Vector(math.cos(a)*ray,-math.sin(a)*ray)-SceneMan:ShortestDistance( self.Pos,Vector(math.cos(a)*ray,-math.sin(a)*ray), true).Normalized*16;
					lc = self:CheckCover(vec.X,vec.Y);
					local dest = vec-self.Pos;
					local ad = SceneMan:ShortestDistance( vec, v, true);
					if lc < c and self:IndirectSensors(vec.X,vec.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
						c = lc;
						aa = a;
						dist = ray-16;
					end
				end
				a = a+da;
			end
			if dist > 0 then
				self:Engines(aa,100);
				return 1;
			else
				return 0;
			end
		end
	end
	function self:LookForComplexPath(X,Y)
		local v = Vector(X,Y);
		if v ~= Vector(-1,-1) then
			local lc = self:CheckCover(self.Pos.X,self.Pos.Y);
			local aa = -math.pi;
			local dist = 0;
			local c = 255;
			local a = -math.pi;
			local da = math.random(300,600)/1000;
			local r = math.random(250,2500)/1000;
			local r2 = math.random(250,2500)/1000;
			local a2 = -math.pi;
			local ray;
			while a < math.pi do
				ray = self:Sensors(a,self.FireRange*self.TargetDetectionRange*r);
				if ray < 0 then
					local vec = self.Pos+Vector(math.cos(a)*self.FireRange*self.TargetDetectionRange*r,-math.sin(a)*self.FireRange*self.TargetDetectionRange*r);
					lc = self:CheckCover(vec.X,vec.Y);
					local dest = vec-self.Pos;
					local ad = SceneMan:ShortestDistance( vec, v, true);
					if lc < c and self:IndirectSensors(vec.X,vec.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
						c = lc;
						aa = a;
						dist = self.FireRange*self.TargetDetectionRange*r;
					else
						a2 = -math.pi;
						while a2 < math.pi do
							ray = self:IndirectSensors(vec.X,vec.Y,math.cos(a2),-math.sin(a2),self.FireRange*self.TargetDetectionRange*r2);
							if ray < 0 then
								local vec2 = vec+Vector(math.cos(a2)*self.FireRange*self.TargetDetectionRange*r2,-math.sin(a2)*self.FireRange*self.TargetDetectionRange*r2);
								lc = self:CheckCover(vec2.X,vec2.Y);
								local dest2 = vec2-vec;
								local ad = SceneMan:ShortestDistance( vec2, v, true);
								if lc < c and self:IndirectSensors(vec2.X,vec2.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
									c = lc;
									aa = a;
									dist = self.FireRange*self.TargetDetectionRange*r;
								end
							elseif ray > 0 then
								local vec2 = vec+Vector(math.cos(a2)*self.FireRange*self.TargetDetectionRange*r2,-math.sin(a2)*self.FireRange*self.TargetDetectionRange*r2)-SceneMan:ShortestDistance( vec,Vector(math.cos(a)*ray,-math.sin(a)*ray), true).Normalized*16;
								lc = self:CheckCover(vec2.X,vec2.Y);
								local dest2 = vec2-vec;
								local ad = SceneMan:ShortestDistance( vec2, v, true);
								if lc < c and self:IndirectSensors(vec2.X,vec2.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
									c = lc;
									aa = a;
									dist = ray-16;
								end
							end
							a2 = a2+da;
						end
					end
				elseif ray > 0 then
					local vec = self.Pos+Vector(math.cos(a)*ray,-math.sin(a)*ray)-SceneMan:ShortestDistance( self.Pos,Vector(math.cos(a)*ray,-math.sin(a)*ray), true).Normalized*16;
					lc = self:CheckCover(vec.X,vec.Y);
					local dest = vec-self.Pos;
					local ad = SceneMan:ShortestDistance( vec, v, true);
					if lc < c and self:IndirectSensors(vec.X,vec.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
						c = lc;
						aa = a;
						dist = ray-16;
					else
						a2 = -math.pi;
						while a2 < math.pi do
							ray = self:IndirectSensors(vec.X,vec.Y,math.cos(a2),-math.sin(a2),self.FireRange*self.TargetDetectionRange*r2);
							if ray < 0 then
								local vec2 = vec+Vector(math.cos(a2)*self.FireRange*self.TargetDetectionRange*r2,-math.sin(a2)*self.FireRange*self.TargetDetectionRange*r2);
								lc = self:CheckCover(vec2.X,vec2.Y);
								local dest2 = vec2-vec;
								local ad = SceneMan:ShortestDistance( vec2, v, true);
								if lc < c and self:IndirectSensors(vec2.X,vec2.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
									c = lc;
									aa = a;
									dist = self.FireRange*self.TargetDetectionRange*r;
								end
							elseif ray > 0 then
								local vec2 = vec+Vector(math.cos(a2)*self.FireRange*self.TargetDetectionRange*r2,-math.sin(a2)*self.FireRange*self.TargetDetectionRange*r2)-SceneMan:ShortestDistance( vec,Vector(math.cos(a)*ray,-math.sin(a)*ray), true).Normalized*16;
								lc = self:CheckCover(vec2.X,vec2.Y);
								local dest2 = vec2-vec;
								local ad = SceneMan:ShortestDistance( vec2, v, true);
								if lc < c and self:IndirectSensors(vec2.X,vec2.Y,ad.X,ad.Y,ad.Magnitude-self.TerrainPenetration) < 0 then
									c = lc;
									aa = a;
									dist = ray-16;
								end
							end
							a2 = a2+da;
						end
					end
				end
				a = a+da;
			end
			if dist > 0 then
				self.TPoint = self.Pos+Vector(math.cos(aa)*dist,-math.sin(aa)*dist);
				self:Engines(aa,100);
			end
		end
	end
	function self:Engines(angle,power)
		if not self.Engined then
			local p = power;
			if p > 1.0 then
				if p <= 100 then
					p = p/100;
				else
					p = 1.0;
				end
			end
			if p < -1.0 then
				if p >= -100 then
					p = p/100;
				else
					p = -1.0;
				end
			end
			local a = self.Acc*p*TimerMan.DeltaTimeSecs;
			self.Vel.X = self.Vel.X+math.cos(angle)*a;
			self.Vel.Y = self.Vel.Y-math.sin(angle)*a;
			self.Engined = true;
		end
	end
	function self:Burst(angle,power)
		if self.BurstTimer:IsPastSimMS(self.BurstTime) then
			self.BurstTimer:Reset();
			self.FireTimer:Reset();
			local p = power;
			if p > 1.0 then
				if p <= 100 then
					p = p/100;
				else
					p = 1.0;
				end
			end
			if p < -1.0 then
				if p >= -100 then
					p = p/100;
				else
					p = -1.0;
				end
			end
			local a = self.BurstAcc*p*TimerMan.DeltaTimeSecs;
			self.Vel.X = self.Vel.X+math.cos(angle)*a;
			self.Vel.Y = self.Vel.Y-math.sin(angle)*a;
			local i = 0;
			if i <= 6*power then
				local e = CreateMOSParticle("Tiny Smoke Ball 1");
				e.Vel.X = self.Vel.X-25*math.cos(angle+(math.random(-10,10)/100))*a;
				e.Vel.Y = self.Vel.Y+25*math.sin(angle+(math.random(-10,10)/100))*a;
				e.Pos = self.Pos;
				MovableMan:AddMO(e);
				i = i+1;
			end
		end
	end
	function self:ManualControl()
		if self.c:IsState(3) then
			self:Engines(0,1.0);
		elseif self.c:IsState(4) then
			self:Engines(math.pi,1.0);
		elseif self.c:IsState(5) then
			self:Engines(math.pi/2,1.0);
		elseif self.c:IsState(6) then
			self:Engines(-math.pi/2,1.0);
		end
		if self.c:IsState(0) then
			if MovableMan:ValidMO(self.Turret) then
				if not self.HFlipped then
					self:Fire(self.Turret.RotAngle,"FAI Shot");
				else
					self:Fire(math.atan2(-math.sin(self.Turret.RotAngle),-math.cos(self.Turret.RotAngle)),"FAI Shot");
				end
			end
		end
	end
	function self:GoTo(Ptx,Pty)
		local Px = Ptx+math.random(-self.ObjectiveImprecision,self.ObjectiveImprecision);
		local Py = Pty+math.random(-self.ObjectiveImprecision,self.ObjectiveImprecision);
		local dist = SceneMan:ShortestDistance( self.Pos,Vector(Px,Py), true);
		if dist.Magnitude > self.ApproachRange then
			local ok = false;
			local a = 0;
			if dist.X > 0 then
				a = math.atan(-dist.Y/dist.X);
			else
				a = math.atan(-dist.Y/dist.X)+math.pi;
			end
			local ai = a;
			local da = self.SensorResolution;
			local i = 1;
			
			while not ok do
				self.Proximity = self.TerrainSensorRange*self.ProximityRatio;
				local ray = self:Sensors(a,self.TerrainSensorRange);
				if ray < 0 then
					ok = true;
					if self.TerrainSensorRange < 400 then
						self.TerrainSensorRange = self.TerrainSensorRange+1.2;
					end
				elseif ray > 0 and ray < self.Proximity then
					ok = true;
					a = a+math.pi;
					if self.TerrainSensorRange > self.SensorMin+self.SensorSweep then
						self.TerrainSensorRange = self.TerrainSensorRange-self.SensorSweep;
					end
				else
					if a > ai then
						a = ai - i*math.random(30,70)*(da/100);
					else
						a = ai + i*math.random(30,70)*(da/100);
						i = i+1;
					end
					if self.TerrainSensorRange > self.SensorMin+self.SensorSweep then
						self.TerrainSensorRange = self.TerrainSensorRange-self.SensorSweep;
					end
					if self.TerrainSensorRange >= 1 then
						self.TerrainSensorRange = self.TerrainSensorRange+math.random(-(self.TerrainSensorVariability*self.TerrainSensorRange)-1,(self.TerrainSensorVariability*self.TerrainSensorRange)+1);
					end
				end
				if i > (2*math.pi/da) then
					if self.TerrainSensorRange < 250 then
						self.TerrainSensorRange = self.TerrainSensorRange+36;
					end
					ok = true;
				end
			end
			self:Engines(a,100);
			if self.Vel.Magnitude < 6*self.SensorReaction and self.TerrainSensorRange < 250 then
				self.TerrainSensorRange = self.TerrainSensorRange+0.1*(30*self.SensorReaction-5*self.Vel.Magnitude*self.SensorReaction);
			end
			
			if math.random(0,10000) <= self.BurstTendency/self.Frequency then
				if math.random(0,1) == 1 then
					self:Burst(a+(math.pi/2),100);
				else
					self:Burst(a-(math.pi/2),100);
				end
			end
						
		end
		if self.NoMoveTimer:IsPastSimMS(self.NoMoveTime) and self.TerrainSensorRange < 250 then
			self.NoMoveTimer:Reset();
			self:LookForComplexPath(self.TPoint.X,self.TPoint.Y)
			self.TerrainSensorRange = self.TerrainSensorRange+self.NoMoveReaction;
		end
	end
	function self:Evade()
		for particle in MovableMan.Particles do
			if particle.HitsMOs == true and particle.Sharpness > 4 and particle.Vel.Magnitude > self.EvadeVel and particle.ClassName ~= "AEmitter" then
				local dist = SceneMan:ShortestDistance( self.Pos,particle.Pos, true);
				if dist.Magnitude < self.EvadeRange then
					local ray = SceneMan:CastMORay(particle.Pos,particle.Vel*1.5,255,128,false,0);
					if ray == self.ID then
						local a = math.atan(-particle.Vel.Y/particle.Vel.X);
						if math.random(0,1) == 1 then
							if self:Sensors(a+((math.pi)/2),20) < 0 then
								a = a+((math.pi)/2);
							else
								a = a-((math.pi)/2);
							end
						else
							if self:Sensors(a-((math.pi)/2),20) < 0 then
								a = a-((math.pi)/2);
							else
								a = a+((math.pi)/2);
							end
						end
						self:Burst(a,100);
					end
				end
			elseif self.FireTimer:IsPastSimMS(self.FireTime) then
				if particle.HitsMOs == true and particle.ClassName == "AEmitter" and (particle.PresetName:lower():find("rocket") ~= nil or particle.PresetName:lower():find("bomb") ~= nil or particle.PresetName:lower():find("grenade") ~= nil or particle.PresetName:lower():find("missile") ~= nil or particle.PresetName:lower():find("rpg") ~= nil) then
					if SceneMan:ShortestDistance( self.Pos,particle.Pos, true).Magnitude < self.InterceptRange then
						self:Intercept(particle.Pos.X,particle.Pos.Y,particle.Vel.X,particle.Vel.Y,"FAI Shot Interceptor");
					end
				end
			end
		end
		
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance( self.Pos,actor.Pos, true);
			if dist.Magnitude < self.EvadeActorRange then
				if actor.Mass > 30 and actor.Vel.Magnitude > self.EvadeActorVel then
					local a = math.atan(-actor.Vel.Y/actor.Vel.X);
					if (math.random(0,1) == 1 and self:Sensors(a+((math.pi)/2),16) < 0) or self:Sensors(a-((math.pi)/2),16) > 0 then
						a = a+((math.pi)/2);	
					else
						a = a-((math.pi)/2);
					end
					self:Burst(a,100);
				end	
			end
		end
	end
	function self:GetTarget()
		if self.Health < self.RetreatTrigger then
			self:LookForCover();
		end
		local distT = Vector(2500,2500);
		local ran = math.random(0,100);
		if self.Vel.X < 0 then
			self.HFlipped = true;
		else
			self.HFlipped = false;
		end
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance( self.Pos,actor.Pos, true);
			if actor.Team ~= self.Team and ((dist.Magnitude < distT.Magnitude) or (ran < self.TargetVariability)) and actor.ClassName ~= "ADoor" then
				if self.TargetVariabilityTimer:IsPastSimMS(self.TargetVariabilityTime) then
					if actor.ClassName == "ACrab" then
						self.TPoint = actor.Pos+Vector(0,-25);
						self.TP = self.TPoint;
					else
						self.TPoint = actor.Pos;
						self.TP = self.TPoint;
					end
					self.TargetVariabilityTimer:Reset();
					if dist.Magnitude < self.PathDist then
						self.PathCounter = 10;
						self.PathPoint = self.TPoint;
					end
				end
				
				distT = SceneMan:ShortestDistance( self.Pos, actor.Pos, true);
				if dist.Magnitude <= self.FireRange then
					local a;
					if dist.X > 0 then
						a = math.atan(-dist.Y/dist.X);
					else
						a = math.atan(-dist.Y/dist.X)+math.pi;
					end
					local tp = self.TerrainPenetration;
					if actor.Mass > 500 then
						tp = 4*tp;
					end
					if dist.X < 0 then
						self.HFlipped = true;
					else
						self.HFlipped = false;
					end
					if self:Sensors(a,(dist.Magnitude)-tp) < 0 then
						self:Intercept(actor.Pos.X,actor.Pos.Y,actor.Vel.X,actor.Vel.Y,"FAI Shot");
						self.TPoint = Vector(self.Pos.X,self.Pos.Y);
					else
						self.TP = Vector(actor.Pos.X,actor.Pos.Y);
					end
				end
			end
		end	
		
		local item;
		if self.DoorTimer:IsPastSimMS(self.DoorTime) then
			for i = 1, MovableMan:GetMOIDCount()-1 do
				item = MovableMan:GetMOFromID(i);
				local dist = SceneMan:ShortestDistance( self.Pos,item.Pos, true);
				if dist.Magnitude <= self.FireRange and item.PresetName:lower():find("door") ~= nil and item.ClassName ~= "ADoor" and item.Team ~= self.Team then
					local a;
					if dist.X > 0 then
						a = math.atan(-dist.Y/dist.X);
						self.HFlipped = false;
					else
						a = math.atan(-dist.Y/dist.X)+math.pi;
						self.HFlipped = true;
					end
					if self.TargetVariabilityTimer:IsPastSimMS(self.TargetVariabilityTime) then
						self.TPoint = item.Pos;
						self.TargetVariabilityTimer:Reset();
					end
					if self:Sensors(a,(dist.Magnitude)-self.TerrainPenetration) < 0 then
						self:Intercept(item.Pos.X,item.Pos.Y,item.Vel.X,item.Vel.Y,"FAI Shot");
					end
					break;
				end
			end
			self.DoorTimer:Reset();
		end
	end
	function self:Fire(angle,Ammo)
		if self.FireTimer:IsPastSimMS(self.FireTime) and MovableMan:ValidMO(self.Turret) then
			local a = angle+(math.random(-self.Inaccuracy*math.abs(angle),self.Inaccuracy*math.abs(angle))/1000);
			local vec = Vector(self.FireVel*math.cos(a),-self.FireVel*math.sin(a));
			local ray = SceneMan:CastMORay(self.Pos,vec,255,128,false,0);
			self:RotateGun(a);
			self.FireTimer:Reset();
			local r = CreateMOPixel(Ammo);
			r:SetWhichMOToNotHit(self,-1);
			r.Pos = self.Turret.Pos+vec.Normalized*4;
			r.Vel = vec;
			MovableMan:AddMO(r);
			local s = CreateMOSRotating("FAI Sound");
			s.Pos = self.Turret.Pos+vec.Normalized*4;
			s.Vel = vec;
			MovableMan:AddMO(s);
			s:GibThis();
			local s = CreateMOSParticle("Fire Puff Small FAI");
			s.Pos = self.Turret.Pos+vec.Normalized*4;
			s.Vel = self.Vel+vec*0.275;
			MovableMan:AddMO(s);
		end
	end
	function self:Intercept(X,Y,VX,VY,Ammo)
		if self.FireTimer:IsPastSimMS(self.FireTime) then
			local vec = Vector(X,Y);
			local vec2 = Vector(VX,VY);
			local d = SceneMan:ShortestDistance(self.Pos, vec, true);
			self.ok = true;
			local tps = d.Magnitude/self.FireVel;
			local pc = vec;
			local idv;
			local id;

			local i = 0;
			while i<self.InterceptAccuracy do
				pc = vec + vec2*tps;
				idv = Vector(pc.X - self.Pos.X, pc.Y - self.Pos.Y);
				id = idv.Magnitude;   
				tps = id/self.FireVel;
				i = i+1;
			end
			
			local idx = -SceneMan:ShortestDistance(pc, self.Pos, true).X;
			local idy = -SceneMan:ShortestDistance(pc, self.Pos, true).Y;
				
			local a;
			if d.X > 0 then
				a = math.atan(-idy/idx);
			else
				a = math.atan(-idy/idx)+math.pi;
			end
			self:Fire(a,Ammo);
		end
	end
	function self:Stabilize()
		if self.RotAngle > 0.1 then
			self.AngularVel = self.AngularVel-(self.AngularAcc*TimerMan.DeltaTimeSecs);
		elseif self.RotAngle < -0.1 then
			self.AngularVel = self.AngularVel+(self.AngularAcc*TimerMan.DeltaTimeSecs);
		end
		self.AngularVel = self.AngularVel*(1.00-(self.AngularRes*TimerMan.DeltaTimeSecs));
	end
	function self:ListenToExternalInput()
		if self.Sharpness > 5 then
			if self.Sharpness > 35 then
				self:ModeProtect();
			elseif self.Sharpness > 25 then
				self:ModeFree();
			elseif self.Sharpness > 15 then
				self:ModeHold();
			end
			self.Sharpness = 0;
		end
	end

	
end 



function Update(self)
	
	self:PositionGun();
	self.Vel = self.Vel*((100-(self.ARes*TimerMan.DeltaTimeSecs))/100);
	
	if self.FrequencyCounter >= 1/self.Frequency then
		self.Engined = false;
		self:ListenToExternalInput();
		
		if not self:IsPlayerControlled() then
			self:Evade();
			if self.TargetTimer:IsPastSimMS(self.TargetTime) then
				self.TargetTimer:Reset();
				self.TP = Vector(-1,-1);
			else
				self:LookForLineOfFire(self.TP.X,self.TP.Y)
				if self.PathCounter > -6 then
					self:PathTo(self.TP.X,self.TP.Y);
				end
			end
			self:GetTarget();
			if self.Mode == "Protect" then
				if MovableMan:IsActor(self.ProtectTarget) then
					local d = SceneMan:ShortestDistance(self.Pos, self.ProtectTarget.Pos, true);
					if d.Magnitude >= self.ProtectRange then
						self.TPoint = self.ProtectTarget.Pos;
					end
				else
					self.Mode = "Hold";
					self.HoldPoint = self.Pos;
				end
			elseif self.Mode == "Hold" then
				local d = SceneMan:ShortestDistance(self.Pos, self.HoldPoint, true);
				self:Glow(d.X,d.Y,"Blue Big");
				if d.Magnitude >= self.ProtectRange then
					self.TPoint = self.HoldPoint;
				end
			end
			--self:GoTo(self.PathPoint.X,self.PathPoint.Y);
			self:GoTo(self.TPoint.X,self.TPoint.Y);
		else
			self:ManualControl();
			self:RotateGun(self:GetAimAngle(true));
		end
		if self.Health <= 0 then
			self:GibThis();
		end
		if self.Vel.Magnitude >= self.NoMove then
			self.NoMoveTimer:Reset();
		end
		if self.Health <= 67 then
			local r = math.random(0,200);
			if r <= (100-self.Health) then
				local e = CreateMOSParticle("Tiny Smoke Ball 1");
				e.Vel = Vector(0.5*self.Vel.X,0.5*self.Vel.Y) + Vector(0,math.random(0,2));
				e.Pos = self.Pos + Vector(math.random(-10,10),math.random(-10,10));	
				MovableMan:AddMO(e);
			end
		end
		self:Stabilize();
		self.FrequencyCounter = 0;
	else
		self:Evade();
		self.FrequencyCounter = self.FrequencyCounter+1;
	end
	if self.ToDelete == true then
		if MovableMan:ValidMO(self.Turret) then
			ToTDExplosive(self.Turret):GibThis();
		end
	end
end

function ExternModeHold(actor)
	ToActor(actor).Sharpness = 20;
end
function ExternModeFree(actor)
	ToActor(actor).Sharpness = 30;
end
function ExternModeProtect(actor)
	ToActor(actor).Sharpness = 40;
end


function Round(n)
	local m = math.floor(n);
	if n%1 >= 0.5 then
		return m+1;
	else
		return m;
	end
end


function FAIGLOW(X,Y,color)
	if not FAIMap then
		FAIMAP();
	end
	local Pos = Vector(X*FAIPathRes,Y*FAIPathRes);
	if Pos.X > 0 and Pos.X < SceneMan.SceneWidth and Pos.Y > 0 and Pos.Y < SceneMan.SceneHeight then
		local r = CreateMOPixel("FAI Test Glow "..color);
		r.Pos = Pos;
		MovableMan:AddMO(r);
	end
end
function FAIMAP()
	FAIMap = true;
	FAIPathRes = 10;
	local x = 0;
	local y = 0;
	FAIPathMap = {};
	while x < SceneMan.Scene.Width/FAIPathRes do
		FAIPathMap[x] = {};
		x = x+1;
	end
	x = 0;
	while y < SceneMan.SceneHeight do
		if SceneMan:GetTerrMatter(Round(x*FAIPathRes),Round(y*FAIPathRes)) == 0 then
			FAIPathMap[x][y] = true;
		else
			FAIPathMap[x][y] = false;
		end
		x = x+1;
		if x >= SceneMan.SceneWidth/FAIPathRes then
			x = 0;
			y = y+1;
		end
	end	
	print("FAI: Scene mapped");
end
function FAIRAY(x,y,X,Y)
	if not FAIMap then
		FAIMAP();
	end
	local lx = Round(x);
	local ly = Round(y);
	local dx = Round(X)-Round(x);
	local dy = Round(Y)-Round(y);
	local a;
	a = math.atan2(-dy,dx);
	while Round(lx) ~= Round(X) or Round(ly) ~= Round(Y) do
		if not FAIPathMap[Round(lx)][Round(ly)] then
			return Vector(Round(lx-math.cos(a)),Round(ly+math.sin(a)));
		end
		lx = lx+math.cos(a);
		ly = ly-math.sin(a);
	end
	return Vector(-1,-1);
end
function FAIRAYGLOW(x,y,X,Y,Color)
	local io = require("io");
	local f = io.open("FAI.rte/debug.txt" , "w+");		
	if not FAIMap then
		FAIMAP();
	end
	FAIGLOW(x,y,"Yellow Long");
	FAIGLOW(X,Y,"Yellow Long");
	local lx = Round(x);
	local ly = Round(y);
	local dx = Round(X)-Round(x);
	local dy = Round(Y)-Round(y);
	local a;
	a = math.atan2(-dy,dx);
	while Round(lx) ~= Round(X) or Round(ly) ~= Round(Y) do
		if not FAIPathMap[Round(lx)][Round(ly)] then
			return Vector(Round(lx-math.cos(a)),Round(ly+math.sin(a)));
		end
		FAIGLOW(Round(lx),Round(ly),Color);
		lx = lx+math.cos(a);
		ly = ly-math.sin(a);
		f:write(Round(lx).." "..Round(ly).."\r\n");
	end
	f:close();
	return Vector(-1,-1);
end

function FAIPATH1(x,y,X,Y,D)
	if not FAIMap then
		FAIMAP();
	end
	
	local lx = x;
	local ly = y;
	local a = -math.pi;
	local a2 = -math.pi;
	local da = 0.1;
	local ray;
	local ray2;
	
	
	while a < math.pi do
		lx = x+D*math.cos(a);
		ly = y-D*math.sin(a);
		if lx-1 > 0 and lx*FAIPathRes+1 < SceneMan.SceneWidth and ly-1 > 0 and ly*FAIPathRes+1 < SceneMan.SceneHeight then
			ray = FAIRAY(x,y,lx,ly);
			if ray == Vector(-1,-1) then
				ray2 = FAIRAY(lx,ly,X,Y);
				if ray2 == Vector(-1,-1) then
					FAIRAYGLOW(x,y,lx,ly,"Red");
					FAIRAYGLOW(lx,ly,X,Y,"Red");
					return Vector(lx,ly);
				end
			else
				ray2 = FAIRAY(ray.X,ray.Y,X,Y);
				if ray2 == Vector(-1,-1) then
					FAIRAYGLOW(ray.X,ray.Y,lx,ly,"Red");
					FAIRAYGLOW(lx,ly,X,Y,"Red");
					return Vector(ray.X,ray.Y);
				end
			end
		end
		a = a+da;
	end	
	return Vector(-1,-1);
			
end

--	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--  --	--	--	--	--

function FAIGLOWA(X,Y,color)
	local Pos = Vector(X,Y);
	if Pos.X > 0 and Pos.X < SceneMan.SceneWidth and Pos.Y > 0 and Pos.Y < SceneMan.SceneHeight then
		local r = CreateMOPixel("FAI Test Glow "..color);
		r.Pos = Pos;
		MovableMan:AddMO(r);
	end
end
function FAIRAYA(x,y,angle,range,res)
	local vec = Vector(math.cos(angle)*range,-math.sin(angle)*range);
	local ray = SceneMan:CastObstacleRay(Vector(x,y) , vec , Vector() , Vector() , 255 , 0 , res);
	if ray > 0 then
		return Vector(x,y)+(vec.Normalized*(ray-res));
	elseif ray < 0 then
		return Vector(-1,-1);
	else
		return Vector(-2,-2);
	end
end
function FAIPATHA(x,y,X,Y,D,Min,DA)
	
	local lx = x;
	local ly = y;
	local a = -math.pi+DA*math.random(0,50)/100;
	local da = DA+DA*math.random(-50,50)/100;
	local a2 = -math.pi;
	local ray;
	local ray2;
	local TerrainPenetration = 30;
	local res = 20;
	local xx;
	local yy;
	local pos;
	local tdist = 25000;
	
	while a < math.pi do
		xx = x+Min*math.cos(a);
		yy = y-Min*math.sin(a);
		lx = xx+D*math.cos(a);
		ly = yy-D*math.sin(a);
		if lx-1 > 0 and lx+1 < SceneMan.SceneWidth and ly-1 > 0 and ly+1 < SceneMan.SceneHeight then
			ray = FAIRAYA(xx,yy,a,D,res);
			if ray == Vector(-1,-1) then
				local dist0 = SceneMan:ShortestDistance( Vector(xx,yy),Vector(lx,ly), true);
				local dist = SceneMan:ShortestDistance( Vector(lx,ly),Vector(X,Y), true);
				a2 = math.atan2(-dist.Y,dist.X);
				ray2 = FAIRAYA(lx,ly,a2,dist.Magnitude-TerrainPenetration,res);
				local dist2 = dist0+dist;
				if ray2 == Vector(-1,-1) and dist2.Magnitude < tdist then
					pos = Vector(lx,ly);
					tdist = dist2.Magnitude;
				end
			elseif ray ~= Vector(-2,-2) then
				local dist0 = SceneMan:ShortestDistance( Vector(xx,yy),ray, true);
				local dist = SceneMan:ShortestDistance( ray,Vector(X,Y), true);
				a2 = math.atan2(-dist.Y,dist.X);
				ray2 = FAIRAYA(ray.X,ray.Y,a2,dist.Magnitude-TerrainPenetration,res);
				local dist2 = dist0+dist;
				if ray2 == Vector(-1,-1) and dist2.Magnitude < tdist then
					pos = Vector(ray.X,ray.Y);
					tdist = dist2.Magnitude;
				end
			end
		end
		a = a+da;
	end	
	if tdist > 20000 then
		return Vector(-1,-1);
	else
		return pos;
	end
			
end

function FAIPATHB(x,y,X,Y,D,Min,DA)
	
	local lx = x;
	local ly = y;
	local a = -math.pi+DA*math.random(0,50)/100;
	local da = DA+DA*math.random(-50,50)/100;
	local ray;
	local ray2;
	local TerrainPenetration = 30;
	local res = 10;
	local xx;
	local yy;
	
	
	while a < math.pi do
		xx = x+Min*math.cos(a);
		yy = y-Min*math.sin(a);
		lx = xx+D*math.cos(a);
		ly = yy-D*math.sin(a);
		if lx-1 > 0 and lx+1 < SceneMan.SceneWidth and ly-1 > 0 and ly+1 < SceneMan.SceneHeight then
			ray = FAIRAYA(xx,yy,a,D,res);
			if ray == Vector(-1,-1) then
				local path = FAIPATHA(lx,ly,X,Y,D,Min,math.pi/12);
				if path ~= Vector(-1,-1) then
					return Vector(lx,ly);
				end
			elseif ray ~= Vector(-2,-2) then
				local path = FAIPATHA(ray.X,ray.Y,X,Y,D,Min,math.pi/12);
				if path ~= Vector(-1,-1) then
					return Vector(ray.X,ray.Y);
				end
			end
		end
		a = a+da;
	end	
	return Vector(-1,-1);
end
function FAIFINDPATH(x,y,X,Y,D,Min)
	local dist = 0.75*D;
	local dd = 0.1;
	while dist < D*3.5 do
		local path = FAIPATHA(x,y,X,Y,dist,Min,math.pi/24);
		if path ~= Vector(-1,-1) then
			return path;
		end
		dist = dist+dd*D;
	end
	dd = 0.5;
	dist = 0.5*D;
	while dist < D*2.5 do
		local path = FAIPATHB(x,y,X,Y,dist,Min,math.pi/6);
		if path ~= Vector(-1,-1) then
			return path;
		end
		dist = dist+dd*D;
	end
	return Vector(-1,-1);
end
function FAIFINDPATHA(x,y,X,Y,D,Min,I)
	local dd = 0.1;
	local dist = (0.75+dd*I)*D;
	local path = FAIPATHA(x,y,X,Y,dist,Min,math.pi/24);
	return path;
end
function FAIFINDPATHB(x,y,X,Y,D,Min,I)
	local dd = 0.5;
	local dist = (0.5+dd*I)*D;
	local path = FAIPATHB(x,y,X,Y,dist,Min,math.pi/6);
	return path;
end


