-- Unique Faction ID
local factionid = "General Industries";
print ("Loading "..factionid)

CF_Factions[#CF_Factions + 1] = factionid

-- Faction name	
CF_FactionNames[factionid] = "General Industries";
-- Set true if faction is selectable by player or AI	
CF_FactionPlayable[factionid] = true;

-- Player controlled actor presets [factionid][actornumber][levelnumber]
CF_PlayerActorPresets[factionid] = {}
CF_PlayerActorPresets[factionid][1] = {"Mercenary lvl 1", "Mercenary lvl 2", "Mercenary lvl 3", "Mercenary lvl 4", "Mercenary lvl 5"}
CF_PlayerActorPresets[factionid][2] = {"Grenadier A lvl 1", "Grenadier A lvl 2", "Grenadier A lvl 3", "Grenadier A lvl 4", "Grenadier A lvl 5"}
CF_PlayerActorPresets[factionid][3] = {"HevRec Marine lvl 1", "HevRec Marine lvl 2", "HevRec Marine lvl 3", "HevRec Marine lvl 4", "HevRec Marine lvl 5"}
CF_PlayerActorPresets[factionid][4] = {"Grenadier B lvl 1", "Grenadier B lvl 2", "Grenadier B lvl 3", "Grenadier B lvl 4", "Grenadier B lvl 5"}
CF_PlayerActorPresets[factionid][5] = {"Juggernaut Unarmed", "Juggernaut Unarmed", "Juggernaut Unarmed", "Juggernaut Unarmed", "Juggernaut Unarmed"}

-- Modules where player controlled actor presets are defined
CF_PlayerActorModules[factionid] = {}
CF_PlayerActorModules[factionid][1] = {"GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte"}
CF_PlayerActorModules[factionid][2] = {"GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte"}
CF_PlayerActorModules[factionid][3] = {"GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte"}
CF_PlayerActorModules[factionid][4] = {"GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte"}
CF_PlayerActorModules[factionid][5] = {"GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte", "GeneralIndustries.rte"}

-- Player character names
CF_PlayerActorNames[factionid] = {"Archer", "Wizard", "Saber", "Barber", "Tank"}

CF_PlayerActorDescriptions[factionid] = {}
CF_PlayerActorDescriptions[factionid][1] = "This wasn't part of the contract. Where the **** am I anyway?"
CF_PlayerActorDescriptions[factionid][2] = "Damnit I need me some explosives. Gettin' twitchy without me' explosives."
CF_PlayerActorDescriptions[factionid][3] = "Damn turrets and thier damned miniguns. I'll put a .50 through 'em all, you'll see."
CF_PlayerActorDescriptions[factionid][4] = "Hey Archer, stop ****ing around and find us some more credits."
CF_PlayerActorDescriptions[factionid][5] = "Where is my sandvich being!? Who took my food!?"

-- CSk checks if all these modules are present to enable or disable faction. These modules must
-- include all modules containing weapons, actors etc
CF_RequiredModules[factionid] = {"GeneralIndustries.rte", "Undead.rte", "Coalition.rte"}

-- RPG effects tables
-- Those explosive are constantly given for every level of Explosives skill
CF_RPGExplosives[factionid] = {{"C-2"}, nil, {"C-4"} , nil}
CF_RPGExplosiveClasses[factionid] = {{"TDExplosive"} , nil, {"TDExplosive"} , nil}

-- Define buyable items available for purchase or unlocks
CF_ItmNames[factionid] = {}
CF_ItmPresets[factionid] = {}
CF_ItmModules[factionid] = {}
CF_ItmPrices[factionid] = {}
CF_ItmDescriptions[factionid] = {}
CF_ItmUnlockData[factionid] = {}
CF_ItmClasses[factionid] = {}

local itm;

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "Medikit"
CF_ItmPresets[factionid][itm] = "Medikit"
CF_ItmModules[factionid][itm] = "CortexShock.rte"
CF_ItmPrices[factionid][itm] = 25
CF_ItmDescriptions[factionid][itm] = "Brings life to everything with two legs."
CF_ItmUnlockData[factionid][itm] = 50

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "C-4 Detonator"
CF_ItmPresets[factionid][itm] = "Detonator"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 5
CF_ItmDescriptions[factionid][itm] = "Detonates placed C-4. Unlimited use."
CF_ItmUnlockData[factionid][itm] = 15

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "G17C"
CF_ItmPresets[factionid][itm] = "G17C"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 25
CF_ItmDescriptions[factionid][itm] = "Standard 17-round Glock, with moderate firepower and range. "
CF_ItmUnlockData[factionid][itm] = 95

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "G18C"
CF_ItmPresets[factionid][itm] = "G18C"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 30
CF_ItmDescriptions[factionid][itm] = "Rapid fire low power sidearm, terrible accuracy."
CF_ItmUnlockData[factionid][itm] = 120

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "G18C Offhand"
CF_ItmPresets[factionid][itm] = "G18C Offhand"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 65
CF_ItmDescriptions[factionid][itm] = "The offhand version of the G18C can be used with a sheild or other firearm. "
CF_ItmUnlockData[factionid][itm] = 180

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "P90"
CF_ItmPresets[factionid][itm] = "P90"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 60
CF_ItmDescriptions[factionid][itm] = "Fast firing reliable firearm, with a 50 round horizontal magazine. Capable of 900 RPM."
CF_ItmUnlockData[factionid][itm] = 350

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "FP6 Breaching Shotgun"
CF_ItmPresets[factionid][itm] = "FP6 Breaching Shotgun"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 65
CF_ItmDescriptions[factionid][itm] = "6-shot close-range breaching shotgun. Offers power over accuracy. "
CF_ItmUnlockData[factionid][itm] = 350

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "HK416"
CF_ItmPresets[factionid][itm] = "HK416"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 75
CF_ItmDescriptions[factionid][itm] = "Long-range accuracy and power in one package. 30 rounds to a magazine firing at 800 RPM."
CF_ItmUnlockData[factionid][itm] = 400

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "OTs-03 SVU"
CF_ItmPresets[factionid][itm] = "OTs-03 SVU"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 95
CF_ItmDescriptions[factionid][itm] = "OTs-03 Snayperskaya Vintovka Ukorochennaya, a 10-round semi-automatic medium range sniper rifle firing heavy subsonic rounds."
CF_ItmUnlockData[factionid][itm] = 400

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "M79"
CF_ItmPresets[factionid][itm] = "M79"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 110
CF_ItmDescriptions[factionid][itm] = "M79 'Thumper' - medium range one-shot grenade launcher. "
CF_ItmUnlockData[factionid][itm] = 410

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "RPK-74"
CF_ItmPresets[factionid][itm] = "RPK-74"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 100
CF_ItmDescriptions[factionid][itm] = "Just hold down the trigger."
CF_ItmUnlockData[factionid][itm] = 410

CF_ItmNames[factionid][itm] = "M95"
CF_ItmPresets[factionid][itm] = "M95"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 145
CF_ItmDescriptions[factionid][itm] = "Splat. Long range sniper weapon system firing .50 cal rounds at supersonic speeds. Comes with a bipod, long range scope, and bipod."
CF_ItmUnlockData[factionid][itm] = 510

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "Milkor MGL"
CF_ItmPresets[factionid][itm] = "Milkor MGL"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 165
CF_ItmDescriptions[factionid][itm] = "Advanced 6-shot grenade launcher capable of 120 RPM. Able to fire multiple ammo types - frag, incendiary and buckshot. "
CF_ItmUnlockData[factionid][itm] = 690

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "LKPI-6"
CF_ItmPresets[factionid][itm] = "LKPI-6"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 95
CF_ItmDescriptions[factionid][itm] = "Launcher, Kinetic Penetrator, Infantry, model 6. Light Anti-armour weapon."
CF_ItmUnlockData[factionid][itm] = 700

itm = #CF_ItmNames[factionid] + 1
CF_ItmNames[factionid][itm] = "LTI-4"
CF_ItmPresets[factionid][itm] = "LTI-4"
CF_ItmModules[factionid][itm] = "GeneralIndustries.rte"
CF_ItmPrices[factionid][itm] = 225
CF_ItmDescriptions[factionid][itm] = "Launcher, Thermobaric, Infantry, model 4. "
CF_ItmUnlockData[factionid][itm] = 820

-- Define enemies fighting against this faction
-- Level 1 enemies and weapons
CF_Weapons[factionid] = {}
CF_WeaponModules[factionid] = {}
CF_Probabilities[factionid] = {}
CF_ExplosiveSets[factionid] = {}
CF_ExplosiveSetModules[factionid] = {}
CF_ActorSets[factionid] = {}
CF_ActorSetModules[factionid] = {}
CF_ArmorCrabs[factionid] = {}
CF_ArmorCrabModules[factionid] = {}
CF_ArmorHumans[factionid] = {}
CF_ArmorHumanModules[factionid] = {}
CF_ArmorHumanWeapons[factionid] = {}
CF_ArmorHumanWeaponModules[factionid] = {}
CF_ArmorPistols[factionid] = {}
CF_ArmorPistolModules[factionid] = {}
CF_ArmorShields[factionid] = {}
CF_ArmorShieldModules[factionid] = {}
CF_Turrets[factionid] = {}
CF_TurretModules[factionid] = {}
CF_TurretOffsetsReplace[factionid] = {}
CF_TurretOffsetsGarrison[factionid] = {}

-- Turrets are mandatory for all levels!!!

-- Probabilities changed!
-- 1. Probability to spawn armored unit
-- 2. Probability to get explosive
-- 3. Probability to get second explosive
CF_Probabilities[factionid][1] = {0, 0.10 , 0};

CF_Weapons[factionid][1] = {"Glock"}
CF_WeaponModules[factionid][1] = {"Ronin.rte"};

CF_ExplosiveSets[factionid][1] = {"Pineapple Grenade"};
CF_ExplosiveSetModules[factionid][1] = {"Ronin.rte"};

CF_ActorSets[factionid][1] = {"Zombie Medium" , "Zombie Thin"};
CF_ActorSetModules[factionid][1] = {"Undead.rte" , "Undead.rte"};

CF_ArmorCrabs[factionid][1] = nil
CF_ArmorCrabModules[factionid][1] = nil

CF_ArmorHumans[factionid][1] = nil
CF_ArmorHumanModules[factionid][1] = nil

CF_ArmorHumanWeapons[factionid][1] = nil
CF_ArmorHumanWeaponModules[factionid][1] = nil

CF_ArmorPistols[factionid][1] = {"Glock"}
CF_ArmorPistolModules[factionid][1] = {"Ronin.rte"}

CF_ArmorShields[factionid][1] = {"Riot Shield"}
CF_ArmorShieldModules[factionid][1] = {"Base.rte"}

CF_Turrets[factionid][1] = {"Gatling Turret"}
CF_TurretModules[factionid][1] = {"Coalition.rte"}

CF_TurretOffsetsReplace[factionid][1] = nil;
CF_TurretOffsetsGarrison[factionid][1] = nil;


-- Level 2 enemies and weapons
CF_Probabilities[factionid][2] = {0, 0.20 , 0};

CF_Weapons[factionid][2] = {"Glock", "Desert Eagle"}
CF_WeaponModules[factionid][2] = {"Ronin.rte", "Ronin.rte"};

CF_ExplosiveSets[factionid][2] = {"Pineapple Grenade"};
CF_ExplosiveSetModules[factionid][2] = {"Ronin.rte"};

CF_ActorSets[factionid][2] = {"Zombie Medium" , "Zombie Thin"};
CF_ActorSetModules[factionid][2] = {"Undead.rte" , "Undead.rte"};

CF_ArmorCrabs[factionid][2] = nil
CF_ArmorCrabModules[factionid][2] = nil

CF_ArmorHumans[factionid][2] = nil
CF_ArmorHumanModules[factionid][2] = nil

CF_ArmorHumanWeapons[factionid][2] = nil
CF_ArmorHumanWeaponModules[factionid][2] = nil

CF_ArmorPistols[factionid][2] = {"Glock"}
CF_ArmorPistolModules[factionid][2] = {"Ronin.rte"}

CF_ArmorShields[factionid][2] = {"Riot Shield"}
CF_ArmorShieldModules[factionid][2] = {"Base.rte"}

CF_Turrets[factionid][2] = nil
CF_TurretModules[factionid][2] = nil

CF_TurretOffsetsReplace[factionid][2] = nil;
CF_TurretOffsetsGarrison[factionid][2] = nil;

-- Level 3 enemies and weapons
CF_Probabilities[factionid][3] = {0, 0.30 , 0.10};

CF_Weapons[factionid][3] = {"Glock", "Desert Eagle", "Peacemaker"}
CF_WeaponModules[factionid][3] = {"Ronin.rte", "Ronin.rte", "Ronin.rte"};

CF_ExplosiveSets[factionid][3] = {"Pineapple Grenade"};
CF_ExplosiveSetModules[factionid][3] = {"Ronin.rte"};

CF_ActorSets[factionid][3] = {"Zombie Medium" , "Zombie Thin"};
CF_ActorSetModules[factionid][3] = {"Undead.rte" , "Undead.rte"};

CF_ArmorCrabs[factionid][3] = nil
CF_ArmorCrabModules[factionid][3] = nil

CF_ArmorHumans[factionid][3] = nil
CF_ArmorHumanModules[factionid][3] = nil

CF_ArmorHumanWeapons[factionid][3] = nil
CF_ArmorHumanWeaponModules[factionid][3] = nil

CF_ArmorPistols[factionid][3] = {"Glock"}
CF_ArmorPistolModules[factionid][3] = {"Ronin.rte"}

CF_ArmorShields[factionid][3] = {"Riot Shield"}
CF_ArmorShieldModules[factionid][3] = {"Base.rte"}

CF_Turrets[factionid][3] = {"Gatling Turret"}
CF_TurretModules[factionid][3] = {"Coalition.rte"}

CF_TurretOffsetsReplace[factionid][3] = nil;
CF_TurretOffsetsGarrison[factionid][3] = nil;

-- Level 4 enemies and weapons
CF_Probabilities[factionid][4] = {0, 0.50 , 0.30};

CF_Weapons[factionid][4] = {"Desert Eagle", "Peacemaker", "Uzi", "Shortgun"}
CF_WeaponModules[factionid][4] = {"Ronin.rte", "Ronin.rte", "Ronin.rte", "Ronin.rte"};

CF_ExplosiveSets[factionid][4] = {"Pineapple Grenade"};
CF_ExplosiveSetModules[factionid][4] = {"Ronin.rte"};

CF_ActorSets[factionid][4] = {"Zombie Medium" , "Zombie Thin"};
CF_ActorSetModules[factionid][4] = {"Undead.rte" , "Undead.rte"};

CF_ArmorCrabs[factionid][4] = nil
CF_ArmorCrabModules[factionid][4] = nil

CF_ArmorHumans[factionid][4] = nil
CF_ArmorHumanModules[factionid][4] = nil

CF_ArmorHumanWeapons[factionid][4] = nil
CF_ArmorHumanWeaponModules[factionid][4] = nil

CF_ArmorPistols[factionid][4] = {"Glock"}
CF_ArmorPistolModules[factionid][4] = {"Ronin.rte"}

CF_ArmorShields[factionid][4] = {"Riot Shield"}
CF_ArmorShieldModules[factionid][4] = {"Base.rte"}

CF_Turrets[factionid][4] = {"Gatling Turret"}
CF_TurretModules[factionid][4] = {"Coalition.rte"}

CF_TurretOffsetsReplace[factionid][4] = nil;
CF_TurretOffsetsGarrison[factionid][4] = nil;

-- Level 5 enemies and weapons
CF_Probabilities[factionid][5] = {0, 0, 0};

CF_Weapons[factionid][5] = {"Uzi", "Shortgun"}
CF_WeaponModules[factionid][5] = {"Ronin.rte", "Ronin.rte"};

CF_ExplosiveSets[factionid][5] = {"Pineapple Grenade"};
CF_ExplosiveSetModules[factionid][5] = {"Ronin.rte"};

CF_ActorSets[factionid][5] = {"Robot 1" , "Robot 2"};
CF_ActorSetModules[factionid][5] = {"Base.rte" , "Base.rte"};

CF_ArmorCrabs[factionid][5] = nil
CF_ArmorCrabModules[factionid][5] = nil

CF_ArmorHumans[factionid][5] = nil
CF_ArmorHumanModules[factionid][5] = nil

CF_ArmorHumanWeapons[factionid][5] = nil
CF_ArmorHumanWeaponModules[factionid][5] = nil

CF_ArmorPistols[factionid][5] = {"Glock"}
CF_ArmorPistolModules[factionid][5] = {"Ronin.rte"}

CF_ArmorShields[factionid][5] = {"Riot Shield"}
CF_ArmorShieldModules[factionid][5] = {"Base.rte"}

CF_Turrets[factionid][5] = {"Gatling Turret"}
CF_TurretModules[factionid][5] = {"Coalition.rte"}

CF_TurretOffsetsReplace[factionid][5] = nil;
CF_TurretOffsetsGarrison[factionid][5] = nil;